import greenfoot.*;


public abstract class AbstractEffect extends MapActor
{
    private long performSuicideAt;
    private boolean keepForever = false;
    
    public AbstractEffect(String key, Location whereToAppear) {
        GifImage image = ImageLoader.get("map.sprite.fx." + key);
        this.performSuicideAt = System.currentTimeMillis() + image.getDuration();
        setImage(image);
        CybervirusHazard.getCurrentMapView().add(this, whereToAppear);
    }
    
    public void setKeepForever(boolean keepForever) {
        this.keepForever = keepForever;
    }
    
    
    public void act() {
        super.act();
        if(performSuicideAt <= System.currentTimeMillis() && !keepForever) suicide();
    }    
}
