import greenfoot.*;
import java.awt.Toolkit;
import javafx.scene.*;
import javafx.scene.text.*;


public abstract class AbstractView extends World {
    public AbstractView() {    
        super((int) (CybervirusHazard.getViewsWidth()),
              (int) (CybervirusHazard.getViewsHeight()),
              2,
              false); 
        CybervirusHazard.setCurrentView(this);
    }
    
    public void fill(Color color) {
        Color oldColor = getBackground().getColor();
        getBackground().setColor(color);
        getBackground().fill();
        getBackground().setColor(oldColor);
    }
    
    public void fill(int hex) {
        fill(new Color((hex >> 16) & 0xFF, (hex >> 8) & 0xFF, (hex >> 0) & 0xFF, 255));
    }
    
    public void add(MapActor actor, Location location) {
        this.addObject(actor, (int) (location.getX() + MapActor.getShakeShiftX()), (int) (location.getY() + MapActor.getShakeShiftY()));
        actor.setLocation(location.getX() + MapActor.getShakeShiftX(),
                          location.getY() + MapActor.getShakeShiftY());
    }
    
    public void add(MapActor actor, double x, double y) {
        add(actor, new Location(x, y));
    }
    
    public void addComposite(CompositeMapActor actor, Location location) {
        add(actor, location);
        for(CompanionActorHolder companion : actor.getCompanions()) {
            add(companion.toActor(), location.add(companion.getRelativeLocation()));
        }
    }
    
    public void addComposite(CompositeMapActor actor, double x, double y) {
        addComposite(actor, new Location(x, y));
    }
}
