import greenfoot.*;


public abstract class CompositeMapActor extends MapActor { 
    public abstract Iterable<CompanionActorHolder> getCompanions();
    
    @Override
    public void move(double distance) {
        super.move(distance);
        for(CompanionActorHolder companion : getCompanions()) {
            Location newCompanionLocation = getLocation().add(companion.getRelativeLocation());
            companion.toActor().setLocation(newCompanionLocation.getX(), newCompanionLocation.getY());
        }
    }
    
    @Override
    public void move(int distance) {
        move((double) distance);
    }
        
    @Override
    public void kill() {
        if(died()) return;
        for(CompanionActorHolder companion : getCompanions()) {
            companion.toActor().kill();
            if(companion.toActor() instanceof Button) CybervirusHazard.debug("Companion is a button");
        }
        super.kill();
    }
    
    /*
     * @Override
    public void turn(int amount) {
        super.turn(amount);
        for(CompanionActor companion : getCompanions()) companion.toActor().turn(amount);
    }
    
    @Override
    public void setRotation(int rotation) {
        super.setRotation(rotation);
        for(CompanionActorHolder companion : getCompanions()) companion.toActor().setRotation(rotation);
    }
    
    @Override
    public void turnTowards(int x, int y) {
        super.turnTowards(x, y);
        for(CompanionActorHolder companion : getCompanions()) companion.toActor().turnTowards(x, y);
    }*/
}
