import greenfoot.*;
import java.awt.Toolkit;
import java.io.IOException;

public final class CybervirusHazard {
    private static AbstractView currentView;
    private static boolean isGameActive = false;
    private static final int VIEWS_WIDTH = 550;
    private static final int VIEWS_HEIGHT = 350;
    private static final String FONT_NAME = "hooge 05_55";
    private static final Label DEBUG_LABEL = new Label();
    private static final boolean DEBUG_MODE_ENABLED = true;
    
    public static void init() {
        try {
            ImageLoader.loadImages();
            SoundLoader.loadSounds();
            TowerParametersManager.init();
            
            Greenfoot.start();
        } catch(IOException e) {}
    }
    
    public static void setCurrentView(AbstractView view) {
        if(view instanceof MapView) isGameActive = true;
        currentView = view;
        Greenfoot.setWorld(view);
    }
    
    public static AbstractView getCurrentView() {
        return currentView;
    }
    
    public static MapView getCurrentMapView() {
        return (MapView) getCurrentView();
    }
    
    public static int getViewsWidth() {
        return VIEWS_WIDTH;
    }
    
    public static int getViewsHeight() {
        return VIEWS_HEIGHT;
    } 
    
    public static void debug(Object message) {
        if(!DEBUG_MODE_ENABLED) return;
        /*if(DEBUG_LABEL.died()) getCurrentMapView().add(DEBUG_LABEL, getViewsWidth() / 2, getViewsHeight() - 30);
        DEBUG_LABEL.setText(message.toString());
        */
        Toast.show("debug", "Debug: " + message, 3000, Color.LIGHT_GRAY);
    }
    
    public static String getFontName() {
        return FONT_NAME;
    }
    
    public static boolean isGameActive() { return isGameActive; }
    
    public static void setGameActive(boolean isGameActive) { CybervirusHazard.isGameActive = isGameActive; }
    
    public static void moveOn() { setGameActive(true); }
    public static void pause() { setGameActive(false); }
}
