import java.util.*;
import greenfoot.*;


public class FileStorage extends MapActor {
    private int health;
    
    public FileStorage() {
        setHealth(3);
    }
    
    public void setHealth(int health) {
        if(health < 0 || health > 3) return;
        this.health = health;
        setImage("map.sprite.file-storage." + health);
        
        if(health <= 0) {
            new EndingPopup("failure");
            Greenfoot.stop();
        }
    }
    
    public void hit() {
        for(Proxy proxy : CybervirusHazard.getCurrentMapView().getObjects(Proxy.class)) {
            if(proxy.canBeUsed()) {
                proxy.use();
                return;
            }
        }
        Toast.show("file-storage-is-attacked", "Storage is under attack!", 3000, Colors.VERY_LIGHT_PURPLE);
        SoundLoader.play("map.sprite.file-storage.damaged");
        setHealth(health - 1);
    }
    
    public void act() {
        super.act();
        if(Math.random() < .20) ParticleSystem.create(new Location((int) (getX() + Math.random() * 16 - 8), getY() + 8), 1, Math.random() < health / 3.0 ? Colors.LEMONADE : Colors.LIGHT_PURPLE, 2, 300L, 1500L, -0.1, 0, 0, 0, -0.4);
    }    
}
