
import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;


public class HealthBar extends MapActor
{
    private AbstractVirus virus;
    private GreenfootImage image;
    private static final int HEALTH_BAR_WIDTH = 30;
    private static final int HEALTH_BAR_HEIGHT = 1;
    private static final int HEALTH_BAR_DISTANCE_TO_VIRUS = 0;
    private static final LinkedHashMap<Double, Color> colorPercentages;

    static {
        colorPercentages = new LinkedHashMap<>();
        colorPercentages.put(0.7, Color.GREEN);
        colorPercentages.put(0.4, Color.YELLOW);
        colorPercentages.put(0.2, Color.ORANGE);
        colorPercentages.put(0.0, Color.RED);
    }
    
    public HealthBar(AbstractVirus virus) {
        this.virus = virus;
        this.image = new GreenfootImage(HEALTH_BAR_WIDTH, HEALTH_BAR_HEIGHT);
    }
    
    public void act() {
        double virusHealthPercents = (double) virus.getHealth() / (double) virus.getMaxHealth();
        image.clear();
        image.setColor(Color.BLACK);
        image.fillRect(0, 0, image.getWidth(), image.getHeight());
        for(java.util.Map.Entry<Double, Color> colorPercentage : colorPercentages.entrySet()) {
            if(virusHealthPercents > colorPercentage.getKey()) {
                image.setColor(colorPercentage.getValue());
                break;
            }
        }
        image.fillRect(0, 0, (int) (((double) image.getWidth()) * virusHealthPercents), image.getHeight());
        setImage(image);
    }    
    
    public static int getHealthBarsDistanceToViruses() {
        return HEALTH_BAR_DISTANCE_TO_VIRUS;
    }
    
    public static int getHealthBarsWidth() {
        return HEALTH_BAR_WIDTH;
    }
    
    public static int getHealthBarsHeight() {
        return HEALTH_BAR_HEIGHT;
    }
}
