public class Hyperjet extends AbstractTower {
    private Location shotLocation = null;
    private boolean soundPlayed = false;
    private long laserActivatedAt = -1;
    
    public Hyperjet() {
        super("Hyperjet");
    }
    
    @Override
    public void act() {
        super.act();
        if(laserActivatedAt == -1) return;
        if(laserActivatedAt != -1) {
            if(!soundPlayed) {
                SoundLoader.play("map.sprite.tower.hyperjet-laser");
                soundPlayed = true;
            }
            new HyperjetLaserParticle(this);
        }
        if(laserActivatedAt + 2000 <= System.currentTimeMillis()) {
            new HyperjetExplosionEffect(shotLocation);
            SoundLoader.play("map.sprite.tower.hyperjet");
            for(AbstractVirus virusInRadius : shotLocation.inRange(100 + 25 * getLevel(), AbstractVirus.class)) {
                virusInRadius.kill();
            }
            shotLocation = null;
            laserActivatedAt = -1;
            soundPlayed = false;
        }
    }
    
    public void fire(AbstractVirus virus) {
        shotLocation = virus.getLocation();
        laserActivatedAt = System.currentTimeMillis();
    }
    
    public boolean activate() {
        return false;
    }
}
