import greenfoot.GreenfootImage;
import java.util.HashMap;
import java.util.stream.Stream;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.nio.file.Path;
import java.io.File;
import java.io.IOException;


public class ImageLoader {
    private static HashMap<String, GifImage> images = new HashMap<>();
    
    public static void loadImages() throws IOException {
        for(File file : new File("images/").listFiles()) {
            String fileName = file.getName().lastIndexOf('.') == -1 ? file.getName() : file.getName().substring(0, file.getName().lastIndexOf('.'));
            images.put(fileName.toLowerCase(), new GifImage(fileName + ".gif"));
        }
    }
    
    public static GifImage get(String key) {
        GifImage originalImage = images.get(key.toLowerCase());
        if(originalImage == null) throw new UnsupportedOperationException("Unable to get image by key: '" + key + "'. Only " + String.join(", ", images.keySet()) + " are available");
        return new GifImage(originalImage);
    }
}
