import java.util.*;
import greenfoot.*;


public class Location {
    public static final Location CENTER = new Location(CybervirusHazard.getViewsWidth() / 2, CybervirusHazard.getViewsHeight() / 2);
    private double x;
    private double y;
    public Location(double x, double y) {
        this.x = x;
        this.y = y;
    }
    
    public double getX() { return x; }
    public double getY() { return y; }
    
    public Location add(Location other) {
        Location location = new Location(x, y);
        location.x += other.getX();
        location.y += other.getY();
        
        return location;
    }
    
    public double distanceTo(Location other) {
        return Math.sqrt(Math.pow(this.getX() - other.getX(), 2) + Math.pow(this.getY() - other.getY(), 2));
    }
    
    public <T extends MapActor> List<T> inRange(int range, Class<T> type) {
        NullActor actor = new NullActor();
        CybervirusHazard.getCurrentMapView().add(actor, this);
        List<T> objectsInRange = actor.inRange(range, type);
        actor.kill();
        return objectsInRange;
    }
}
