public class MainMenu extends AbstractView {
    private static class WorldButton extends MapActor {
        private Map map;
        private String name;
        private String description;
        
        public WorldButton(String name, String description, Map map) {
            this.map = map;
            this.name = name;
            this.description = description;
            setImage(Images.create(Colors.DARK_GRAY, CybervirusHazard.getViewsWidth() / 4, 40));
            
        }
        
        public Map getMap() {
            return map;
        }
        
        public String getName() {
            return name;
        }
        
        public String getDescription() {
            return description;
        }
    }
    
    public MainMenu() {
        super();
        CybervirusHazard.init();
        setBackground(ImageLoader.get("menu.main").getCurrentImage());
        add(new InvisibleButton(100, () -> CybervirusHazard.setCurrentView(new MapView())), 392, 290);
        add(new InvisibleButton(100, () -> CybervirusHazard.setCurrentView(new HelpMenu())), 478, 290);
    }
}
