import java.util.List;
import java.util.ArrayList;

public class Map {
    private VirusPath virusPath;
    private List<Location> slotLocations;
    private WaveManager waveManager;
    
    public Map(VirusPath virusPath, WaveManager waveManager, List<Location> slotLocations) {
        this.virusPath = virusPath;
        this.slotLocations = slotLocations;
        this.waveManager = waveManager;
    }
    
    public Map(VirusPath virusPath, WaveManager waveManager, Location... slotLocations) {
        this(virusPath, waveManager, List.of(slotLocations));
    }
    
    public VirusPath getVirusPath() { return virusPath; }
    
    public List<Location> getSlotLocations() {
        return slotLocations;
    }
    
    public WaveManager getWaveManager() {
        return waveManager;
    }
}
