import greenfoot.*;


public class ParticleSystem {
    public static void create(Location where, 
                              int count, 
                              Color color, 
                              int size, 
                              long minLifetime, 
                              long maxLifetime, 
                              double gravitation, 
                              double maxVelocityX, 
                              double minVelocityX, 
                              double maxVelocityY, 
                              double minVelocityY,
                              double sizeReduction) {
        for(int i = 0; i < count; i++) 
            CybervirusHazard.getCurrentMapView().add(
                new Particle(color, 
                             size, 
                             minLifetime + (long) (Math.random() * (maxLifetime - minLifetime)), 
                             gravitation, 
                             minVelocityX + Math.random() * (maxVelocityX - minVelocityX), minVelocityY + Math.random() * (maxVelocityY - minVelocityY),
                             sizeReduction), 
                where); 
    }
    
    public static void create(Location where, 
                              int count, 
                              Color color, 
                              int size, 
                              long minLifetime, 
                              long maxLifetime, 
                              double gravitation, 
                              double maxVelocityX, 
                              double minVelocityX, 
                              double maxVelocityY, 
                              double minVelocityY) {
        create(where, count, color, size, minLifetime, minLifetime, gravitation, maxVelocityX, minVelocityX, maxVelocityY, minVelocityY, 1);
    }
    
    public static void create(Location where, 
                              int count, 
                              String key, 
                              long minLifetime, 
                              long maxLifetime, 
                              double gravitation, 
                              double maxVelocityX, 
                              double minVelocityX, 
                              double maxVelocityY, 
                              double minVelocityY,
                              double sizeReduction) {
        for(int i = 0; i < count; i++) 
            CybervirusHazard.getCurrentMapView().add(
                new Particle(key, 
                             minLifetime + (long) (Math.random() * (maxLifetime - minLifetime)), 
                             gravitation, 
                             minVelocityX + Math.random() * (maxVelocityX - minVelocityX), minVelocityY + Math.random() * (maxVelocityY - minVelocityY),
                             sizeReduction), 
                where); 
    }
    
    public static void create(Location where, 
                              int count, 
                              String key, 
                              long minLifetime, 
                              long maxLifetime, 
                              double gravitation, 
                              double maxVelocityX, 
                              double minVelocityX, 
                              double maxVelocityY, 
                              double minVelocityY) {
        create(where, count, key, minLifetime, minLifetime, gravitation, maxVelocityX, minVelocityX, maxVelocityY, minVelocityY, 1);
    }
}
