import greenfoot.*; 


public final class ScreenFogger extends InterfaceElement {
    private static boolean enabled = false;
    private static ScreenFogger fogger = null;
    private GreenfootImage image;
    
    private ScreenFogger() {
        this.image = new GreenfootImage(CybervirusHazard.getViewsWidth() * 2, CybervirusHazard.getViewsHeight() * 2);
        this.image.setColor(new Color(0, 0, 0, 200));
        this.image.fill();
        this.setImage(image);
    }
    
    public static void setEnabled(boolean enabled) {
        ScreenFogger.enabled = enabled;
        if(fogger != null) fogger.kill();
        fogger = enabled ? new ScreenFogger() : null;
        if(enabled) CybervirusHazard.getCurrentMapView().add(fogger, CybervirusHazard.getViewsWidth() / 2, CybervirusHazard.getViewsHeight() / 2);
    }
    
    public void act() {
        super.act();
        setImage(image);
    }
    
    public static void enable() {
        setEnabled(true);
    }
    
    public static void disable() {
        setEnabled(false);
    }
    
    protected static ScreenFogger getInstance() {
        return fogger;
    }
}
