import greenfoot.GreenfootSound;
import java.util.HashMap;
import java.util.stream.Stream;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.nio.file.Path;
import java.io.File;
import java.io.IOException;


public class SoundLoader {
    private static HashMap<String, String> sounds = new HashMap<>();
    
    public static void loadSounds() throws IOException {
        for(File file : new File("sounds/").listFiles()) {
            String fileName = file.getName().lastIndexOf('.') == -1 ? file.getName() : file.getName().substring(0, file.getName().lastIndexOf('.'));
            sounds.put(fileName.toLowerCase(), file.getName());
        }
    }
    
    public static void play(String key) {
        String fileName = sounds.get(key.toLowerCase());
        if(fileName != null) new GreenfootSound(fileName).play();
    }
}
