import greenfoot.*;
import java.util.List;


public class TowerMarketCard extends CompositeInterfaceElement { 
    private static final int DISTANCE_BETWEEN_CARD_AND_PRICE = 6;
    private Icon towerIcon;
    private Label towerCost;
    private String towerName;
    private TowerSlot towerSlot;
    
    public TowerMarketCard(String name, TowerSlot target) {
        this.towerIcon = new Icon("map.ui.tower-select." + name.toLowerCase().replace(" ", "-"), true);
        this.towerCost = new Label(TowerParametersManager.getPrice(name));
        this.towerCost.setOrientation(LabelOrientation.CENTER);
        this.towerSlot = target;
        this.towerName = name;
    }
    
    public Iterable<CompanionActorHolder> getCompanions() {
        return List.of(); // Надеюсь, никто не заметит)))))))))))))))))))))))))
    }
    
    public Iterable<CompanionActorHolder> getCardElements() {
        return List.of(new CompanionActorHolder(towerIcon, new Location(0, 0)), new CompanionActorHolder(towerCost, new Location(0, 0)));
    }
    
    public Icon getIcon() {
        return towerIcon;
    }
    
    public Label getLabel() {
        return towerCost;
    }
    
    @Override
    public void act() {
        super.act();
        if(Greenfoot.mouseClicked((Actor) towerIcon) || Greenfoot.mouseClicked((Actor) towerCost)) {
            if(CybervirusHazard.getCurrentMapView().hasEnoughEnergy(TowerParametersManager.getPrice(towerName))) {
                CybervirusHazard.getCurrentMapView().removeEnergy(TowerParametersManager.getPrice(towerName));
                CybervirusHazard.getCurrentMapView().addComposite(TowerFactory.createTower(towerName), towerSlot.getLocation());
                ParticleSystem.create(towerSlot.getLocation(), 12, "tower-buy-sparkle", 6000L, 8000L, .1, -2.5, 2.5, -3.5, 0.5, 0.9);
                towerSlot.kill();
                TowerMarketScreen.close();
            } else {
                Toast.show("lack-of-energy", "You have no energy to buy a " + towerName, 2000, Colors.VERY_LIGHT_PURPLE);
                SoundLoader.play("map.ui.denied");
            }
        }
    }
}
