import greenfoot.*;
import java.util.List;
import java.util.ArrayList;

public class TowerMarketScreen extends CompositeInterfaceElement {
    private static TowerMarketScreen screen = null;
    List<TowerMarketCard> cards = new ArrayList();
    
    private TowerMarketScreen(TowerSlot slot) {
        cards.add(new TowerMarketCard("Scanner", slot));
        cards.add(new TowerMarketCard("Antivirus", slot));
        cards.add(new TowerMarketCard("Noise Generator", slot));
        cards.add(new TowerMarketCard("Firewall", slot));
        cards.add(new TowerMarketCard("Proxy", slot));
        cards.add(new TowerMarketCard("Hyperjet", slot));
        
        CybervirusHazard.getCurrentMapView().addComposite(this, Location.CENTER);
        screen = this;
    }
    
    public static boolean isOpened() {
        return screen != null;
    }
    
    protected static void setOpened(TowerSlot slot, boolean opened) {
        ScreenFogger.setEnabled(opened);
        if(screen != null) screen.kill();
        screen = opened ? new TowerMarketScreen(slot) : null;
    }
    
    public static void open(TowerSlot slot) {
        setOpened(slot, true);
    }
    
    public static void close() {
        setOpened(null, false);
    }
    
    @Override
    public Iterable<CompanionActorHolder> getCompanions() {
        List companions = new ArrayList<>();
        int i = 0;
        for(TowerMarketCard card : cards) {
            for(CompanionActorHolder holder : card.getCardElements()) {
                companions.add(holder.redefineHolder(new Location(-CybervirusHazard.getViewsWidth() / 3 - 50 + 92 * (i / 2) + (i % 2 == 0 ? 0 : 0), -CybervirusHazard.getViewsHeight() / 4 + (i % 2 == 0 ? 0 : 40))));
                i++;
            }
            companions.add(new CompanionActorHolder(card, new Location(0, 0))); // Абсолютно наплевать, какая здесь позиция
        }
        
        return companions;
    }
    
    public void act() {
        super.act();
        if(Greenfoot.isKeyDown("Escape")) close();
    }
}
