import java.util.HashMap;


public final class TowerParametersManager {
    private static final HashMap<String, TowerParameters[]> towerParameters = new HashMap<>();
    
    public static void init() {
        towerParameters.put("Scanner", new TowerParameters[]{
            new TowerParameters(400, 100, 10, 400),
            new TowerParameters(380, 110, 12, 1000),
            new TowerParameters(350, 115, 15, 2000),
            new TowerParameters(320, 120, 20, 5000),
            new TowerParameters(300, 125, 24, 10000),
            new TowerParameters(275, 130, 30, 15000),
            new TowerParameters(250, 135, 36, 25000),
            new TowerParameters(220, 140, 45, 30000),
            new TowerParameters(200, 145, 50, 40000),
            new TowerParameters(180, 150, 70, 50000)
        });
        
        towerParameters.put("Antivirus", new TowerParameters[]{
            new TowerParameters(2000, 9999, 2, 800),
            new TowerParameters(1900, 9999, 2, 1000),
            new TowerParameters(1800, 9999, 3, 2000),
            new TowerParameters(1750, 9999, 4, 4000),
            new TowerParameters(1700, 9999, 5, 8000),
            new TowerParameters(1650, 9999, 7, 12000),
            new TowerParameters(1600, 9999, 11, 15000),
            new TowerParameters(1600, 9999, 15, 20000),
            new TowerParameters(1550, 9999, 20, 25000),
            new TowerParameters(1500, 9999, 25, 30000)
        });
        
        towerParameters.put("Noise Generator", new TowerParameters[]{
            new TowerParameters(200, 100, 0, 400),
            new TowerParameters(180, 110, 0, 1000),
            new TowerParameters(160, 115, 0, 2000),
            new TowerParameters(135, 120, 0, 5000),
            new TowerParameters(110, 125, 0, 10000),
            new TowerParameters(95, 130, 0, 15000),
            new TowerParameters(80, 135, 0, 25000),
            new TowerParameters(75, 140, 0, 30000),
            new TowerParameters(72, 145, 0, 40000),
            new TowerParameters(70, 150, 0, 50000)
        });
        
        towerParameters.put("Firewall", new TowerParameters[]{
            new TowerParameters(7000, 100, 0, 700),
            new TowerParameters(6500, 110, 0, 1000),
            new TowerParameters(6100, 115, 0, 2000),
            new TowerParameters(5700, 120, 0, 5000),
            new TowerParameters(5400, 125, 0, 10000),
            new TowerParameters(5200, 130, 0, 15000),
            new TowerParameters(5000, 135, 0, 25000),
            new TowerParameters(4800, 140, 0, 30000),
            new TowerParameters(4550, 145, 0, 40000),
            new TowerParameters(4200, 150, 0, 50000)
        });
        
        towerParameters.put("Proxy", new TowerParameters[]{
            new TowerParameters(7000, 100, 0, 700),
            new TowerParameters(6500, 110, 0, 1000),
            new TowerParameters(6100, 115, 0, 2000),
            new TowerParameters(5700, 120, 0, 5000),
            new TowerParameters(5400, 125, 0, 10000),
            new TowerParameters(5200, 130, 0, 15000),
            new TowerParameters(5000, 135, 0, 25000),
            new TowerParameters(4800, 140, 0, 30000),
            new TowerParameters(4550, 145, 0, 40000),
            new TowerParameters(4200, 150, 0, 50000)
        });
        
        towerParameters.put("Hyperjet", new TowerParameters[]{
            new TowerParameters(10000, 9999, 0, 10000),
            new TowerParameters(9000, 9999, 0, 25000),
            new TowerParameters(8000, 9999, 0, 70000),
            new TowerParameters(6500, 9999, 0, 150000),
            new TowerParameters(5000, 9999, 0, 250000)
        });
    }
    
    public static TowerParameters get(String name, int level) {
        return towerParameters.get(name)[level - 1];
    }
    
    public static int getUpgradePrice(String name, int level) {
        return get(name, level).getCost();
    }
    
    public static int getPrice(String name) {
        return getUpgradePrice(name, 1);
    }
    
    public static boolean isMaxLevel(String name, int level) {
        return towerParameters.get(name).length < level;
    }
}
