
import greenfoot.*;


public class TowerRadiusVisualizer extends MapActor {
    private GreenfootImage image;
    private AbstractTower tower;
    private boolean visible;
    private boolean drawn;
    private static final Color COLOR = Colors.LEMONADE;
    private static final int FILL_TRANSPARENCY = 7;
    
    public TowerRadiusVisualizer(AbstractTower tower) {
        this.tower = tower;
        this.visible = false;
        this.drawn = false;
        //this.image = new GreenfootImage(tower.getParameters().getRadius() * 4, tower.getParameters().getRadius() * 4);
    }
    
    public void act() {
        if(false) { // Java outing of memory, when image is being created
            super.act();
            if(tower.died()) {
                suicide();
                return;
            }
            if(tower.getParameters().getRadius() != image.getWidth() * 4 && visible) {
                this.image = new GreenfootImage(tower.getParameters().getRadius() * 4, tower.getParameters().getRadius() * 4);
                drawn = false;
            }
            if(visible && !drawn) {
                this.drawn = true;
                this.image.setColor(new Color(COLOR.getRed(), COLOR.getGreen(), COLOR.getBlue(), FILL_TRANSPARENCY)); 
                this.image.fillOval(0, 0, tower.getParameters().getRadius() * 4, tower.getParameters().getRadius() * 4);
            }
            setImage(image);
        }
    }   
    
    public void toggleVisibility() { visible = !visible; }
}
