import java.util.ArrayList;
import java.util.List;

public class VirusPath {
    private FileStorage fileStorage;
    private ArrayList<NullActor> nullActors = new ArrayList<>();
    
    public VirusPath(MapView view, Location... vertexes) {
        if(vertexes.length < 2) throw new UnsupportedOperationException("A virus path should have at least 2 vertexes, not " + vertexes.length);
        for(Location vertex : vertexes) {
            NullActor nullActor = new NullActor();
            view.add(nullActor, vertex);
            nullActors.add(nullActor);
        }
        
        fileStorage = new FileStorage();
        view.add(fileStorage, new Location(vertexes[vertexes.length - 1].getX() / 2, vertexes[vertexes.length - 1].getY() / 2));
    }
    
    public ArrayList<NullActor> getNullActors() {
        return nullActors;
    }
    
    public Location getVirusSpawnLocation() {
        return nullActors.get(0).getLocation();
    }
    
    public Location getFileStorageLocation() {
        return nullActors.get(nullActors.size() - 1).getLocation();
    }
    
    public FileStorage getFileStorage() {
        return fileStorage;
    }
}
