public class Wave {
    
    private String virusType;
    private int amount;
    private long delay;
    private long lastGeneratedTime;
    private int virusesLeft;
    private long extraDelay = 0;
    
    public Wave(String virusType, int amount, long delay) {
        this.virusType = virusType;
        this.amount = amount;
        this.delay = delay;
        this.lastGeneratedTime = System.currentTimeMillis();
        this.virusesLeft = amount;
    }
    
    public String getVirusType() { return virusType; }
    public int getAmount() { return amount; }
    public long getDelay() { return delay; }
    
    public boolean isVirusShouldBeCreated() {
        return lastGeneratedTime + delay + extraDelay <= System.currentTimeMillis() && !isOver();
    }
    
    public AbstractVirus createVirus() {
        if(isOver()) throw new UnsupportedOperationException("Unable to generate a new virus, because wave is over");
        lastGeneratedTime = System.currentTimeMillis();
        extraDelay = 0;
        virusesLeft--;
        
        return VirusFactory.createVirus(virusType);
    }
    
    public boolean isOver() {
        return virusesLeft <= 0;
    }
    
    public void addExtraDelay(long milliseconds) {
        this.extraDelay += milliseconds;
    }
}
